/*
 * gps.c
 *
 *  Created on: 2024621
 *      Author: 14662
 */


#include "main.h"

void UART8_Init(uint16_t baudrate){
    GPIO_InitTypeDef GPIO_InitStructure;
    USART_InitTypeDef USART_InitStructure;
    NVIC_InitTypeDef NVIC_InitStructure;

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART8, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOE, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);//AFIOʱ

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_14;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOE, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_15;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init(GPIOE, &GPIO_InitStructure);

        //ӳʲô
    GPIO_PinRemapConfig(GPIO_FullRemap_USART8, ENABLE);

    USART_InitStructure.USART_BaudRate = baudrate;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
    USART_Init(UART8, &USART_InitStructure);

    USART_ITConfig(UART8, USART_IT_RXNE, ENABLE);

    NVIC_InitStructure.NVIC_IRQChannel = UART8_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);

    USART_Cmd(UART8, ENABLE);
}

#define BUFFER_SIZE 256

char buffer[BUFFER_SIZE];
int buffer_index = 0;
extern char latitude[16];
extern char longitude[16];

void parseGPGGA(char *nmea) {
    char *token;
    int field = 0;

    token = strtok(nmea, ",");
    while (token != NULL) {
        field++;
        if (field == 3) {
            strcpy(latitude, token);
        } else if (field == 5) {
            strcpy(longitude, token);
        }
        token = strtok(NULL, ",");
    }
}

void parseNMEA(char *nmea) {
    if (strstr(nmea, "$GPGGA") != NULL) {
        parseGPGGA(nmea);
    }
}

__attribute__((interrupt))
void UART8_IRQHandler(void){
    if (USART_GetITStatus(UART8, USART_IT_RXNE) != RESET) {
        char c = USART_ReceiveData(UART8);
        if (c == '\n' || c == '\r') {
            if (buffer_index > 0) {
                buffer[buffer_index] = '\0';
                parseNMEA(buffer);
                buffer_index = 0;
            }
        } else {
            if (buffer_index < BUFFER_SIZE - 1) {
                buffer[buffer_index++] = c;
            }
        }
    }
}
