
#include "main.h"

//
//
uint8_t a1;
uint8_t b1;
uint8_t c1;
uint8_t d1;
uint8_t e1;
uint8_t f1;

///*gy91ģʼ־*/
//static char gy91_init_flag;

/*mpu9250*/
float ax_org,ay_org,az_org,gx_org,gy_org,gz_org;
float ax_lpf_1,ay_lpf_1,az_lpf_1,gx_lpf_1,gy_lpf_1,gz_lpf_1;
float ax_lpf_2,ay_lpf_2,az_lpf_2,gx_lpf_2,gy_lpf_2,gz_lpf_2;
float gx_offset,gy_offset,gz_offset;

uint8_t mpu9250_read_reg(uint8_t addr)
{
    MPU9250_CS_L();
    uint8_t data = spi3_read_reg(addr);
    MPU9250_CS_H();
    return data;
}

void mpu9250_write_reg(uint8_t addr, uint8_t data)
{
    MPU9250_CS_L();
    spi3_wirte_reg(addr, data);
    MPU9250_CS_H();
}



void mpu9250_init(void)
{
    //״̬
    a1 = mpu9250_read_reg(PWR_MGMT_1);
    b1 = mpu9250_read_reg(PWR_MGMT_2);
    c1 = mpu9250_read_reg(CONFIG);
    d1 = mpu9250_read_reg(SMPLRT_DIV);
    e1 = mpu9250_read_reg(GYRO_CONFIG);
    f1 = mpu9250_read_reg(ACCEL_CONFIG);

    while(mpu9250_read_reg(PWR_MGMT_1)!=0x00)
    mpu9250_write_reg(PWR_MGMT_1  , 0x00);
    vTaskDelay(50);

    while(mpu9250_read_reg(PWR_MGMT_2)!=0x00)
    mpu9250_write_reg(PWR_MGMT_2  , 0x00);

    //رֵͨ˲
    while(mpu9250_read_reg(CONFIG)!=0x00)
    mpu9250_write_reg(CONFIG      , 0x00);

    // 8KHz
    while(mpu9250_read_reg(SMPLRT_DIV)!=0x00)
    mpu9250_write_reg(SMPLRT_DIV  , 0x00);

    // +-500/s       bit4:bit3   0:+-250/s;   1:+-500/s;   2:+-1000/s;   3:+-2000/s;
    while(mpu9250_read_reg(GYRO_CONFIG)!=0x10)
    mpu9250_write_reg(GYRO_CONFIG , 0x10);

    //ٶ +-8G           bit4:bit3   0:+-2G;   1:+-4G;   2:+-8G;   3:+-16G;
    while(mpu9250_read_reg(ACCEL_CONFIG)!=0x10)
    mpu9250_write_reg(ACCEL_CONFIG, 0x10);

    //ȡ
    mpu9250_read();
}

// MPU9250 ȡ
void mpu9250_read(void)
{
    #define q_lpf(fc)       (fc * 2.0f * 3.14159265f * 0.00025f) // һ׵ͨ˲ϵ

    uint8_t u8Buf[2];
//    if(gy91_init_flag)
//    {
        // ȡٶȼ
        u8Buf[0] = mpu9250_read_reg(ACCEL_XOUT_H); // X
        u8Buf[1] = mpu9250_read_reg(ACCEL_XOUT_L);
        ax_org = (int16_t)((u8Buf[0] << 8) | u8Buf[1]);

        u8Buf[0] = mpu9250_read_reg(ACCEL_YOUT_H); // Y
        u8Buf[1] = mpu9250_read_reg(ACCEL_YOUT_L);
        ay_org = (int16_t)((u8Buf[0] << 8) | u8Buf[1]);

        u8Buf[0] = mpu9250_read_reg(ACCEL_ZOUT_H); // Z
        u8Buf[1] = mpu9250_read_reg(ACCEL_ZOUT_L);
        az_org = (int16_t)((u8Buf[0] << 8) | u8Buf[1]);

        // ȡ
        u8Buf[0] = mpu9250_read_reg(GYRO_XOUT_H); // X
        u8Buf[1] = mpu9250_read_reg(GYRO_XOUT_L);
        gx_org = (((int16_t)((u8Buf[0] << 8) | u8Buf[1])) * 0.0005322862f);

        u8Buf[0] = mpu9250_read_reg(GYRO_YOUT_H); // Y
        u8Buf[1] = mpu9250_read_reg(GYRO_YOUT_L);
        gy_org = (((int16_t)((u8Buf[0] << 8) | u8Buf[1])) * 0.0005322862f);

        u8Buf[0] = mpu9250_read_reg(GYRO_ZOUT_H); // Z
        u8Buf[1] = mpu9250_read_reg(GYRO_ZOUT_L);
        gz_org = (((int16_t)((u8Buf[0] << 8) | u8Buf[1])) * 0.0005322862f);

        // һ׵ͨ˲
        ax_lpf_1 += q_lpf(20) * (ax_org - ax_lpf_1);
        ay_lpf_1 += q_lpf(20) * (ay_org - ay_lpf_1);
        az_lpf_1 += q_lpf(20) * (az_org - az_lpf_1);
        gx_lpf_1 += q_lpf(20) * ((gx_org - gx_offset) - gx_lpf_1);
        gy_lpf_1 += q_lpf(20) * ((gy_org - gy_offset) - gy_lpf_1);
        gz_lpf_1 += q_lpf(20) * ((gz_org - gz_offset) - gz_lpf_1);

        ax_lpf_2 += q_lpf(80) * (ax_org - ax_lpf_2);
        ay_lpf_2 += q_lpf(80) * (ay_org - ay_lpf_2);
        az_lpf_2 += q_lpf(80) * (az_org - az_lpf_2);
        gx_lpf_2 += q_lpf(80) * ((gx_org - gx_offset) - gx_lpf_2);
        gy_lpf_2 += q_lpf(80) * ((gy_org - gy_offset) - gy_lpf_2);
        gz_lpf_2 += q_lpf(80) * ((gz_org - gz_offset) - gz_lpf_2);
//    }
}

/*bmp280*/
float p_org,t_org;

uint8_t bmp280_read_reg(uint8_t addr)
{
    BMP280_CS_L();
    uint8_t data = spi3_read_reg(addr);
    BMP280_CS_H();
    return data;
}

void bmp280_write_reg(uint8_t addr, uint8_t data)
{
    BMP280_CS_L();
    spi3_wirte_reg(addr, data);
    BMP280_CS_H();
}

short bmp280_multiple_read_two(unsigned char addr)
{
    unsigned char msb, lsb;
    short temp = 0;
    lsb = bmp280_read_reg(addr);
    msb = bmp280_read_reg(addr + 1);

    temp = (short)msb << 8;
    temp |= (short)lsb;

    return temp;
}

long bmp280_multiple_read_three(unsigned char addr)
{
    unsigned char msb, lsb, xlsb;
    long temp = 0;
    msb = bmp280_read_reg(addr);
    lsb = bmp280_read_reg(addr + 1);
    xlsb = bmp280_read_reg(addr + 2);
    temp = (long)(((unsigned long)msb << 12)|((unsigned long)lsb << 4)|((unsigned long)xlsb >> 4));
    return temp;
}

static unsigned short dig_T1;
static short dig_T2;
static short dig_T3;
static unsigned short dig_P1;
static short dig_P2;
static short dig_P3;
static short dig_P4;
static short dig_P5;
static short dig_P6;
static short dig_P7;
static short dig_P8;
static short dig_P9;

void bmp280_init(void)
{
    bmp280_write_reg(0xe0, 0xb6);//λ
        vTaskDelay(50);
    bmp280_write_reg(0xf4, 0xff);//
    bmp280_write_reg(0xf5, 0x00);//˲
    vTaskDelay(50);
    dig_T1 = bmp280_multiple_read_two(0x88);
    dig_T2 = bmp280_multiple_read_two(0x8A);
    dig_T3 = bmp280_multiple_read_two(0x8C);
    dig_P1 = bmp280_multiple_read_two(0x8E);
    dig_P2 = bmp280_multiple_read_two(0x90);
    dig_P3 = bmp280_multiple_read_two(0x92);
    dig_P4 = bmp280_multiple_read_two(0x94);
    dig_P5 = bmp280_multiple_read_two(0x96);
    dig_P6 = bmp280_multiple_read_two(0x98);
    dig_P7 = bmp280_multiple_read_two(0x9A);
    dig_P8 = bmp280_multiple_read_two(0x9C);
    dig_P9 = bmp280_multiple_read_two(0x9E);
}

void bmp280_read(void)
{
    long adc_T;
    long adc_P;
    long var1, var2, t_fine;

//    if(gy91_init_flag)
//   {
        adc_T = bmp280_multiple_read_three(BMP280_TEMP_ADDR);
        adc_P = bmp280_multiple_read_three(BMP280_PRESS_ADDR);
        if(adc_P == 0)
        {
           p_org=0;
        }
        //Temperature
        var1 = ((adc_T)/16384.0f-(dig_T1)/1024.0f)*(dig_T2);
        var2 = (((adc_T)/131072.0f-(dig_T1)/8192.0f)*((adc_T)/131072.0f-(dig_T1)/8192.0f))*(dig_T3);
        t_fine = (unsigned long)(var1+var2);
        t_org = (var1+var2)/5120.0f;
        var1 = (t_fine/2.0f)-64000.0f;
        var2 = var1*var1*(dig_P6)/32768.0f;
        var2 = var2 +var1*(dig_P5)*2.0f;
        var2 = (var2/4.0f)+((dig_P4)*65536.0f);
        var1 = ((dig_P3)*var1*var1/524288.0f+(dig_P2)*var1)/524288.0f;
        var1 = (1.0f+var1/32768.0f)*(dig_P1);
        p_org = 1048576.0f-adc_P;
        p_org = (p_org-(var2/4096.0f))*6250.0f/var1;
        var1 = (dig_P9)*p_org*p_org/2147483648.0f;
        var2 = p_org*(dig_P8)/32768.0f;
        p_org = p_org+(var1+var2+(dig_P7))/16.0f;
//    }
}

//gy91ʼ
void gy91_init(void)
{
    //Ƭѡųʼ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
    GPIO_InitTypeDef GPIO_InitStructure;
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6 | GPIO_Pin_7; // PB6:MPU9250_CS    PB7:BMP280_CS
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;

    GPIO_Init(GPIOB, &GPIO_InitStructure);
    GPIO_SetBits(GPIOB,GPIO_Pin_6| GPIO_Pin_7);
    vTaskDelay(50);
    bmp280_init();
    mpu9250_init();
//    gy91_init_flag=1;
}









