
#ifndef HAL_GY91_H_
#define HAL_GY91_H_

/******************************************mpu9250********************************************/

// MPU9250_CS
#define MPU9250_CS_H()   GPIO_SetBits   (GPIOB,GPIO_Pin_7);
#define MPU9250_CS_L()   GPIO_ResetBits (GPIOB,GPIO_Pin_7);

//MPU9250ڲĴַ
#define SMPLRT_DIV         0x19
#define CONFIG           0x1A
#define GYRO_CONFIG        0x1B
#define ACCEL_CONFIG       0x1C
#define ACCEL_CONFIG_2   0x1D
#define ACCEL_XOUT_H       0x3B
#define ACCEL_XOUT_L       0x3C
#define ACCEL_YOUT_H       0x3D
#define ACCEL_YOUT_L       0x3E
#define ACCEL_ZOUT_H       0x3F
#define ACCEL_ZOUT_L       0x40
#define GYRO_XOUT_H        0x43
#define GYRO_XOUT_L        0x44
#define GYRO_YOUT_H        0x45
#define GYRO_YOUT_L        0x46
#define GYRO_ZOUT_H        0x47
#define GYRO_ZOUT_L        0x48
#define PWR_MGMT_1         0x6B
#define PWR_MGMT_2         0x6C
#define WHO_AM_I         0x75

extern float ax_org,ay_org,az_org,gx_org,gy_org,gz_org;
extern float ax_lpf_1,ay_lpf_1,az_lpf_1,gx_lpf_1,gy_lpf_1,gz_lpf_1;
extern float ax_lpf_2,ay_lpf_2,az_lpf_2,gx_lpf_2,gy_lpf_2,gz_lpf_2;
extern float gx_offset,gy_offset,gz_offset;

/******************************************bmp280********************************************/

// BMP280_CS
#define BMP280_CS_H()    GPIO_SetBits   (GPIOB,GPIO_Pin_6);
#define BMP280_CS_L()    GPIO_ResetBits (GPIOB,GPIO_Pin_6);

//BMP280ڲĴַ
#define BMP280_TEMP_ADDR    0xfa
#define BMP280_PRESS_ADDR   0xf7

extern float t_org,p_org;

/**************************************************************************************/
void mpu9250_read(void);
void bmp280_read(void);
void gy91_init(void);


#endif /* HAL_GY91_H_ */
