/*
 * telectrl_Task.c
 *
 *  Created on: 2024617
 *      Author: 14662
 */

#include "main.h"


uint8_t telectrl_rx_buf[32];
uint8_t telectrl_tx_buf[4096];

float mlx90640To[768];
char latitude[16];
char longitude[16];

float  throttle;//
float  pitch_tar;
float  roll_tar;
float  yaw_tar;

uint16_t mlx_tx_size;
uint16_t gps_tx_size;

uint16_t mlx_wz_data1;
uint16_t mlx_wz_data2;
uint16_t gps_wz_data;



void telectrl_task(void * pvParameters)
{
    unsigned char nrf_status;

    while(1)
    {
        mlx_tx_size = sizeof(mlx90640To) / sizeof(mlx90640To[0]);
        mlx_wz_data1 = 1;
        mlx_wz_data2 = mlx_tx_size * sizeof(float) + mlx_wz_data1;
        gps_wz_data = mlx_wz_data2 + 1 + sizeof(latitude);


        telectrl_tx_buf[0] = mlx_tx_size;
        memcpy(telectrl_tx_buf + mlx_wz_data1, mlx90640To, mlx_tx_size * sizeof(float));
        telectrl_tx_buf[mlx_wz_data2] = sizeof(latitude);
        memcpy(telectrl_tx_buf + mlx_wz_data2 + 1, latitude, sizeof(latitude));
        telectrl_tx_buf[gps_wz_data - 1] = sizeof(longitude);
        memcpy(telectrl_tx_buf + gps_wz_data, longitude, sizeof(longitude));


        nrf_status=nrf_read_reg(NRF_STATUS);
        if(nrf_status&0x40)
        {
            //״̬
            nrf_write_reg(NRF_STATUS,nrf_status);
            //հ
            nrf_read_buf(NRF_RD_RX_PLOAD,telectrl_rx_buf,32);
            //
            nrf_send_large_packet(telectrl_tx_buf,4096);

            //ݴ
            float roll_temp  =(telectrl_rx_buf[0]-111);if(fabs(roll_temp )<10.0f)roll_temp  =0.0f;if(roll_temp >0)roll_temp -=10.0f;if(roll_temp <0)roll_temp +=10.0f;roll_tar =+roll_temp *0.005f;
            float pitch_temp =(telectrl_rx_buf[1]-135);if(fabs(pitch_temp)<10.0f)pitch_temp =0.0f;if(pitch_temp>0)pitch_temp-=10.0f;if(pitch_temp<0)pitch_temp+=10.0f;pitch_tar=+pitch_temp*0.005f;
            float yaw_temp   =(telectrl_rx_buf[2]-134);if(fabs(yaw_temp  )<10.0f)yaw_temp   =0.0f;if(yaw_temp  >0)yaw_temp  -=10.0f;if(yaw_temp  <0)yaw_temp  +=10.0f;yaw_tar  =-yaw_temp  *0.005f;
            throttle         =(telectrl_rx_buf[3]-000)*3.0f;



        }
        vTaskDelay(configTICK_RATE_HZ/400);
    }
}

