
#include "main.h"

#define FPS2HZ   0x02
#define FPS4HZ   0x03
#define FPS8HZ   0x04
#define FPS16HZ  0x05
#define FPS32HZ  0x06

#define MLX90640_ADDR 0x33
#define RefreshRate FPS16HZ
#define TA_SHIFT 8

static uint16_t eeMLX90640[832];
extern float mlx90640To[768];
uint16_t frame[834];
float emissivity = 0.95;
int status;
float vdd;
float ta;
float tr;

void temp_task(void * arg){
    MLX90640_I2CInit();
    MLX90640_SetRefreshRate(MLX90640_ADDR, FPS16HZ);

    paramsMLX90640 mlx90640;
    status = MLX90640_DumpEE(MLX90640_ADDR, eeMLX90640);
    if (status != 0) {
        while(1);
    }

    status = MLX90640_ExtractParameters(eeMLX90640, &mlx90640);
    if (status != 0) {
        while(1);
    }

    while (1) {
        status = MLX90640_GetFrameData(MLX90640_ADDR, frame);
        if (status < 0) {
            continue;
        }
        vdd = MLX90640_GetVdd(frame, &mlx90640);
        ta = MLX90640_GetTa(frame, &mlx90640);
        tr = ta - TA_SHIFT;
        MLX90640_CalculateTo(frame, &mlx90640, emissivity, tr, mlx90640To);
        vTaskDelay(configTICK_RATE_HZ/400);
    }
}
